/* gIR.c */

#include <stdio.h>
#include <unistd.h>
#include <gnome.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <string.h>
#include "gIR.h"
#include "reception.h"
#include "gestion_code.h"
#include "gestion_action.h"


////////////////////////////////////////////////////////////////
static void quitbox_cb(GtkWidget* widget, void* data);
static void quit_cb(GtkWidget* widget);
static void new_child_cb(GtkWidget* widget, gpointer data);
static void a_propos_cb(GtkWidget* widget, void* data);
static void mbox_cb(GtkWidget* widget, void* data);
void ajouter_menu_cb( GtkWidget *widget);
void supprimer_menu_cb(GtkWidget* widget);
void liste_code_menu_cb(GtkWidget* widget);
void test_menu_cb(GtkWidget* widget);
void debug_cb(GtkWidget* widget, void* data);
void bip_cb(GtkWidget* widget, void* data);
void background_cb(GtkWidget* widget);
static GtkWidget * WindowBox;

gtkBox * toto;
int debug=0;

////////////////////////////////////////////////////////////////
static GnomeUIInfo file_menu[]= {
{
	GNOME_APP_UI_ITEM,
	N_("_Ajouter une action"), N_("Ajoute une action"),
	ajouter_menu_cb, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	'A', GDK_CONTROL_MASK, NULL
},
{
	GNOME_APP_UI_ITEM,
	N_("_Supprimer une action"), N_("Supprime une action"),
	supprimer_menu_cb, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	'S', GDK_CONTROL_MASK, NULL
},
{
	GNOME_APP_UI_ITEM,
	N_("_Liste des actions"), N_("Liste des actions enregistres"),
	liste_code_menu_cb, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	'L', GDK_CONTROL_MASK, NULL
},
{
	GNOME_APP_UI_ITEM,
	N_("_Tester une action"), N_("Tester une action"),
	test_menu_cb, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	'T', GDK_CONTROL_MASK, NULL
},
	GNOMEUIINFO_SEPARATOR,
{
	GNOME_APP_UI_ITEM,
	N_("Lancer en arrire _plan"), N_("Lancer en arrire plan"),
	background_cb, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	'P', GDK_CONTROL_MASK, NULL
},
	GNOMEUIINFO_SEPARATOR,
{
	GNOME_APP_UI_ITEM,
	N_("_Dbugage"), N_("(ds)Active le dbugage"),
	debug_cb, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	'D', GDK_CONTROL_MASK, NULL
},
{
	GNOME_APP_UI_ITEM,
	N_("_Beep"), N_("(ds)Active les bip"),
	bip_cb, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	'B', GDK_CONTROL_MASK, NULL
},
	GNOMEUIINFO_SEPARATOR,
{
	GNOME_APP_UI_ITEM,
	N_("E_xit"), N_("Exit"),
	quit_cb, NULL, NULL,
	GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_QUIT,
	'Q', GDK_CONTROL_MASK, NULL
},
	GNOMEUIINFO_END
};


static GnomeUIInfo doc_menu []={
	// GNOMEUIINFO_ITEM_STOCK("Documentation",NULL,doc_cb, GNOME_STOCK_MENU_NEW),
	GNOMEUIINFO_END
};

static GnomeUIInfo help_menu []={
{
	GNOME_APP_UI_ITEM,
	N_("_Informations"), N_("Infos"),
	mbox_cb, NULL, NULL,
	GNOME_APP_PIXMAP_NONE, NULL,
	0, (GdkModifierType)0, NULL
},
	GNOMEUIINFO_SEPARATOR,
{
	GNOME_APP_UI_ITEM,
	N_("_About..."), N_("Info about gIR"),
	a_propos_cb, NULL, NULL,
	GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_ABOUT,
	0, (GdkModifierType)0, NULL
},
	GNOMEUIINFO_END
};

static GnomeUIInfo main_menu []={
	GNOMEUIINFO_SUBTREE("_File", &file_menu),
	//GNOMEUIINFO_SUBTREE("_Doc", &doc_menu),
	GNOMEUIINFO_SUBTREE("_Help", &help_menu),
	GNOMEUIINFO_END
};

static GnomeMDI* mdi;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Courtes boites de dialogues (informations)
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
static void mbox_cb(GtkWidget* widget, void* data)
{
	GtkWidget* mbox;
	mbox = gnome_message_box_new(
		"Ce logiciel sert a commander votre P.C. via le port srie\n
		Usage: ./recepteur_IR <action> [\"parametre\"]\n
		Liste des actions:\n
		ajouter <parametre>: permet d'ajouter un nouveau code infrarouge. Exemple: recepteur_IR ajouter \"xmms -p &\"\n
		Vous pouvez egalement mettre recepteur_IR -a debug \"xmms -p &\" pour dbuguer\n
		supprimer [parametre], o le parametre est le nom de la commande. Si vous ne precisez pas de parametre, ce sera un code de la telecommande\n
		background [parametre]: lance le logiciel en arrire plan (des qu'il y a quelque chose sur le port, l'action correspondantes est execute). Le parametre possible est debug.\n
		test: execute la reception d'un code (scrute le port srie 32 fois, execute la commande si elle existe, et affiche diverses informations)",
		GNOME_MESSAGE_BOX_INFO, GNOME_STOCK_BUTTON_OK, NULL);
	gtk_widget_show (mbox);
}

////////////////////////////////////////////////////////////////
static void a_propos_cb(GtkWidget* widget, void* data)
{
	GtkWidget* a_propos;
	const gchar* auteurs[]={
		"Cedric ARROUET <carrouet@enib.fr>",
		"Xavier IZARD <xizard@enib.fr",
		NULL
	};
	a_propos=gnome_about_new("gIR",VERSION,"(c) 2001 Cedric Xavier",auteurs,
	"Ce logiciel sert  commander votre P.C. via le port srie\n
	Interface GTK : Cedric & Xavier\n
	Gestion du port srie et de la tlcommande IR : Xavier",NULL);
	gtk_widget_show(a_propos);
}

////////////////////////////////////////////////////////////////
void pb_root_cb(void)
{
	GtkWidget* mbox;
	mbox = gnome_message_box_new("Impossible d'ouvrir le port COM2\nLe logiciel doit etre install en root",
	GNOME_MESSAGE_BOX_ERROR,GNOME_STOCK_BUTTON_OK,NULL);
	gtk_widget_show (mbox);
}

////////////////////////////////////////////////////////////////
void pb_file_cb(void)
{
	GtkWidget* mbox;
	mbox = gnome_message_box_new("Aucun code enregistr! (fichier inexistant)",
	GNOME_MESSAGE_BOX_WARNING,GNOME_STOCK_BUTTON_OK,NULL);
	gtk_widget_show (mbox);
}

////////////////////////////////////////////////////////////////
void pb_port_cb(void)
{
	GtkWidget* mbox;
	mbox = gnome_message_box_new("Erreur  l'ouverture du port srie",
	GNOME_MESSAGE_BOX_ERROR,GNOME_STOCK_BUTTON_OK,NULL);
	gtk_widget_show (mbox);
}

////////////////////////////////////////////////////////////////
void pb_background_cb(void)
{
	GtkWidget* mbox;
	mbox = gnome_message_box_new("Erreur dans la mise en arrire plan",
	GNOME_MESSAGE_BOX_ERROR,GNOME_STOCK_BUTTON_OK,NULL);
	gtk_widget_show (mbox);
}

////////////////////////////////////////////////////////////////
void info_cb(GtkWidget* machin, char* data)
{
	GtkWidget* mbox;
	mbox = gnome_message_box_new(data,
	GNOME_MESSAGE_BOX_INFO,GNOME_STOCK_BUTTON_OK,NULL);
	gtk_widget_show (mbox);
}

////////////////////////////////////////////////////////////////
void get_code_action_cb(gtkBox * toto)
{
	toto->appuyerBox = gnome_message_box_new("Appuyez sur la touche correpondante de la tlcommande",
	GNOME_MESSAGE_BOX_GENERIC,NULL);
	gtk_widget_show(toto->appuyerBox);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Fonctions de destruction de certaine boites de dialogue, et fonctions de fin de programme
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
void quit(void)
{
	printf("gIR version %s Compilation %s %s\n",VERSION,__DATE__,__TIME__);
	printf("%s\t%s\n",COPYLEFT,AUTHORS);
	exit(-1);
}

////////////////////////////////////////////////////////////////
static void quit_cb(GtkWidget* widget)
{
	//gtk_widget_destroy(widget);
	free(toto->ajouter);
	free(toto->supprimer);
	free(toto->lister);
	free(toto);
	gtk_main_quit();
}

////////////////////////////////////////////////////////////////
void quit_action_cb(GtkWidget *source , GtkWidget *widget)
{
	gtk_widget_hide(widget);
	//  gdk_window_hide(widget);
}

////////////////////////////////////////////////////////////////
void debug_cb(GtkWidget* widget, void* data)
{
	toto->debug= 1 - toto->debug;
}

////////////////////////////////////////////////////////////////
void bip_cb(GtkWidget* widget, void* data)
{
	toto->bip= 1 - toto->bip;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Fenetres des fonctions d'ajouts d'lments
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
void ajouter_action_OK_cb(gtkBox * toto)
{
	toto->ajouter->mBox = gnome_message_box_new("Code ajout!",
	GNOME_MESSAGE_BOX_INFO,GNOME_STOCK_BUTTON_OK,NULL);
	gtk_widget_show(toto->ajouter->mBox);
}

////////////////////////////////////////////////////////////////
void ajouter_action_pasOK_cb(gtkBox * toto)
{
	toto->ajouter->mBox = gnome_message_box_new("Il manque la commande  assigner au code infra rouge!",
	GNOME_MESSAGE_BOX_WARNING,GNOME_STOCK_BUTTON_OK,NULL);
	gtk_widget_show(toto->ajouter->mBox);
}

////////////////////////////////////////////////////////////////
void ajouter_action_cb( GtkWidget *widget,gtkBox * toto)
{
	gchar *entry_text;
	entry_text = gtk_entry_get_text(GTK_ENTRY(toto->ajouter->nameBox));
	quit_action_cb(toto->ajouter->windowAction,toto->ajouter->windowAction);
	//while (gtk_events_pending()) gtk_main_iteration();
	ajouter_f(entry_text,toto->debug,toto);
}

////////////////////////////////////////////////////////////////
static void ajouter_cb(GtkWidget* widget, gtkBox * toto)
{
	if (toto->ajouter->ajout == 0)
	{
		toto->ajouter->ajout = 1;
		toto->ajouter->windowAction = gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_window_set_title(GTK_WINDOW(toto->ajouter->windowAction), "Ajouter une action");
		toto->ajouter->mainBox = gtk_hbox_new(FALSE, 5);
		gtk_container_add(GTK_CONTAINER(toto->ajouter->windowAction),  toto->ajouter->mainBox);
		gtk_container_border_width(GTK_CONTAINER(toto->ajouter->windowAction), 5);
		//gtk_signal_connect(GTK_OBJECT(toto->ajouter->windowAction), "delete_event", GTK_SIGNAL_FUNC(quit_action_cb), toto->ajouter->windowAction);
		toto->ajouter->pBox = gtk_vbox_new(FALSE, 5);
		toto->ajouter->label=gtk_label_new("Action  enregistrer :");
		gtk_box_pack_start(GTK_BOX(toto->ajouter->pBox),toto->ajouter->label, FALSE, FALSE, 2);
		gtk_widget_show(toto->ajouter->label);
		toto->ajouter->nameBox=gtk_entry_new();
		gtk_signal_connect(GTK_OBJECT(toto->ajouter->nameBox),"activate",GTK_SIGNAL_FUNC(ajouter_action_cb),toto);
		gtk_box_pack_start(GTK_BOX(toto->ajouter->pBox), toto->ajouter->nameBox, TRUE, TRUE, 2);
		gtk_widget_show(toto->ajouter->nameBox);
		toto->ajouter->button=gtk_button_new_with_label("Enregistrer");
		gtk_signal_connect(GTK_OBJECT(toto->ajouter->button),"clicked",  GTK_SIGNAL_FUNC(ajouter_action_cb),toto);
		gtk_box_pack_end(GTK_BOX(toto->ajouter->pBox),toto->ajouter->button, FALSE, TRUE, 2);
		gtk_widget_show(toto->ajouter->button);

		gtk_widget_show(toto->ajouter->pBox);
		gtk_container_add(GTK_CONTAINER( toto->ajouter->mainBox),toto->ajouter->pBox);
		gtk_widget_show(toto->ajouter->mainBox);
		gtk_widget_show(toto->ajouter->windowAction);
		gtk_widget_grab_focus(toto->ajouter->nameBox);
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Fenetres des fonctions de suppression d'lments
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
void supprimer_action_OK_cb(gtkBox * toto)
{
	toto->supprimer->mBox = gnome_message_box_new("Le code  supprimer a t trouv et supprim",
	GNOME_MESSAGE_BOX_INFO,GNOME_STOCK_BUTTON_OK,NULL);
	gtk_widget_show(toto->supprimer->mBox);
	//gnome_dialog_set_parent(toto->supprimer->mBox, WindowBox);
}

////////////////////////////////////////////////////////////////
void supprimer_action_pasOK_cb(gtkBox * toto)
{
	toto->supprimer->mBox = gnome_message_box_new("Le code  supprimer n'a pas t trouv",
	GNOME_MESSAGE_BOX_WARNING,GNOME_STOCK_BUTTON_OK,NULL);
	gtk_widget_show(toto->supprimer->mBox);
}

////////////////////////////////////////////////////////////////
void supprimer_action_cb( GtkWidget *widget, gtkBox * toto)
{
	gchar *entry_text;
	entry_text = gtk_entry_get_text(GTK_ENTRY(toto->supprimer->nameBox));
	quit_action_cb(toto->supprimer->windowAction,toto->supprimer->windowAction);
	//while (gtk_events_pending()) gtk_main_iteration();
	supprimer_f(entry_text,toto);
}

////////////////////////////////////////////////////////////////
void supprimer_cb(GtkWidget* widget, gtkBox * toto)
{
	if(toto->supprimer->suppression == 0)
	{
		toto->supprimer->suppression = 1;
		toto->supprimer->windowAction = gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_window_set_title(GTK_WINDOW(toto->supprimer->windowAction), "Supprimer une action");
		toto->supprimer->mainBox = gtk_hbox_new(FALSE, 5);
		gtk_container_add(GTK_CONTAINER(toto->supprimer->windowAction), toto->supprimer->mainBox);
		gtk_container_border_width(GTK_CONTAINER(toto->supprimer->windowAction), 5);
		//gtk_signal_connect(GTK_OBJECT(toto->supprimer->windowAction), "delete_event", GTK_SIGNAL_FUNC(quit_action_cb), toto->supprimer->windowAction);
		toto->supprimer->pBox = gtk_vbox_new(FALSE, 5);
		toto->supprimer->label=gtk_label_new("Action  supprimer :");
		gtk_box_pack_start(GTK_BOX(toto->supprimer->pBox),toto->supprimer->label, FALSE, FALSE, 2);
		gtk_widget_show(toto->supprimer->label);
		toto->supprimer->nameBox=gtk_entry_new();
		//Quan	d on vient de taper une cation, si on appuye sur entre, alors on lance ajouter_f :
		gtk_signal_connect(GTK_OBJECT(toto->supprimer->nameBox),"activate",GTK_SIGNAL_FUNC(supprimer_action_cb),toto);
		gtk_box_pack_start(GTK_BOX(toto->supprimer->pBox), toto->supprimer->nameBox, TRUE, TRUE, 2);
		gtk_widget_show(toto->supprimer->nameBox);
		toto->supprimer->button=gtk_button_new_with_label("Supprimer");
		gtk_signal_connect(GTK_OBJECT(toto->supprimer->button),"clicked", GTK_SIGNAL_FUNC(supprimer_action_cb),toto);
		gtk_box_pack_end(GTK_BOX(toto->supprimer->pBox), toto->supprimer->button, FALSE, TRUE, 2);
		gtk_widget_show(toto->supprimer->button);

		gtk_widget_show(toto->supprimer->pBox);
		gtk_container_add(GTK_CONTAINER(toto->supprimer->mainBox),toto->supprimer->pBox);
		gtk_widget_show(toto->supprimer->mainBox);
		gtk_widget_show(toto->supprimer->windowAction);
		//Quand on arrive dans la boite de dialogue, on est directement dans la zone de saisie :
		gtk_widget_grab_focus(toto->supprimer->nameBox);
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Fenetres des fonctions de listage des actions, de test, et de mise en arriere-plan
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
void liste_code_cb(GtkWidget* widget, gtkBox * toto)
{
	FILE *fichier;
	//int i=0;
	unsigned char *codeLu;
	char **commande;
	if (toto->lister->listing == 0)
	{
		toto->lister->listing = 1;
		toto->lister->windowAction = gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_window_set_title(GTK_WINDOW(toto->lister->windowAction), "Liste des actions");
		toto->lister->mainBox = gtk_hbox_new(FALSE, 5);
		gtk_container_add(GTK_CONTAINER(toto->lister->windowAction), toto->lister->mainBox);
		gtk_container_border_width(GTK_CONTAINER(toto->lister->windowAction), 5);
		//gtk_signal_connect(GTK_OBJECT(toto->lister->windowAction), "delete_event", GTK_SIGNAL_FUNC(quit_action_cb),toto->lister->windowAction);
		toto->lister->pBox = gtk_vbox_new(FALSE, 5);
		toto->lister->label=gtk_label_new("Liste des actions enregistres :");
		gtk_box_pack_start(GTK_BOX(toto->lister->pBox),toto->lister->label, FALSE, FALSE, 2);
		gtk_widget_show(toto->lister->label);

		toto->lister->liste=gtk_clist_new(1);
		codeLu=(unsigned char *)malloc(65*sizeof(unsigned char));
		commande=(char **)malloc(sizeof(char*));
		*commande=(char *)malloc(64*sizeof(char));
		fichier=fopen(DATA_FILE,"r");
		if (fichier==NULL)
		{
			pb_file_cb();
			printf("Aucun code enregistr! (fichier inexistant)\n");
			exit(0);
		}

		do
		{
			fread(codeLu,1,64,fichier);
			fscanf(fichier," %[^\n]\n",*commande);
			gtk_clist_append(GTK_CLIST(toto->lister->liste),commande);
		}
		while (!feof(fichier));
		fclose(fichier);

		gtk_box_pack_start(GTK_BOX(toto->lister->pBox),toto->lister->liste, TRUE, TRUE, 2);
		gtk_widget_show(toto->lister->liste);

		toto->lister->button=gtk_button_new_with_label("OK");
		gtk_signal_connect(GTK_OBJECT(toto->lister->button),"clicked", GTK_SIGNAL_FUNC(quit_action_cb),toto->lister->windowAction);
		gtk_box_pack_end(GTK_BOX(toto->lister->pBox), toto->lister->button, FALSE, TRUE, 2);
		gtk_widget_show(toto->lister->button);

		gtk_widget_show(toto->lister->pBox);
		gtk_container_add(GTK_CONTAINER(toto->lister->mainBox),toto->lister->pBox);
		GTK_WIDGET_SET_FLAGS(toto->lister->button,GTK_CAN_DEFAULT);	//permet de simuler le click sur le bouton
		gtk_widget_grab_default(toto->lister->button);                   //quand on appuye sur entre
		gtk_widget_show(toto->lister->mainBox);
		gtk_widget_show(toto->lister->windowAction);

		free(*commande);
		free(commande);
	}
	toto->lister->listing = 0;
}

////////////////////////////////////////////////////////////////
void test_cb(GtkWidget* widget,gtkBox * toto)
{
	if (toto->tester->test == 0)
	{
		toto->tester->test = 1;
		toto->tester->windowAction = gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_window_set_title(GTK_WINDOW(toto->tester->windowAction), "Test d'une touche");
		toto->tester->mainBox = gtk_hbox_new(FALSE, 5);
		gtk_container_add(GTK_CONTAINER(toto->tester->windowAction), toto->tester->mainBox);
		gtk_container_border_width(GTK_CONTAINER(toto->tester->windowAction), 5);
		toto->tester->pBox = gtk_table_new (5, 20, FALSE);
		gtk_table_set_row_spacings (GTK_TABLE (toto->tester->pBox),2);
		//gtk_table_set_row_spacing (GTK_TABLE (toto->tester->pBox), 0, 2);
		//gtk_table_set_col_spacing (GTK_TABLE (toto->tester->pBox), 0, 2);

		toto->tester->label=gtk_label_new("Liste des octets reus :");
		gtk_table_attach (GTK_TABLE (toto->tester->pBox), toto->tester->label, 0, 20, 0, 1,
				GTK_EXPAND | GTK_SHRINK | GTK_FILL,
				GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
		gtk_widget_show(toto->tester->label);

		toto->tester->textBox = gtk_text_new (NULL, NULL);
		gtk_table_attach (GTK_TABLE (toto->tester->pBox), toto->tester->textBox, 0, 19, 1, 2,
				GTK_EXPAND | GTK_SHRINK | GTK_FILL,
				GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
		gtk_widget_show(toto->tester->textBox);

		toto->tester->barreDefilante=gtk_vscrollbar_new(GTK_TEXT(toto->tester->textBox)->vadj);
		gtk_table_attach_defaults(GTK_TABLE(toto->tester->pBox),toto->tester->barreDefilante,19,20,1,2);
		gtk_widget_show(toto->tester->barreDefilante);

		toto->tester->labelCorrespondance=gtk_label_new("Correspondance :");
		gtk_table_attach (GTK_TABLE (toto->tester->pBox), toto->tester->labelCorrespondance, 0,20, 2, 3,
				GTK_EXPAND | GTK_SHRINK | GTK_FILL,
				GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
		gtk_widget_show(toto->tester->labelCorrespondance);

		toto->tester->correspondanceBox = gtk_entry_new();
		gtk_table_attach_defaults(GTK_TABLE (toto->tester->pBox),toto->tester->correspondanceBox, 0, 20, 3, 4);
		gtk_entry_set_editable(GTK_ENTRY(toto->tester->correspondanceBox),FALSE);
		gtk_widget_show(toto->tester->correspondanceBox);

		toto->tester->button=gtk_button_new_with_label("OK");
		gtk_table_attach (GTK_TABLE (toto->tester->pBox), toto->tester->button, 0, 20, 4, 5,
				GTK_EXPAND | GTK_SHRINK | GTK_FILL,
				GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
		gtk_signal_connect(GTK_OBJECT(toto->tester->button),"clicked", GTK_SIGNAL_FUNC(quit_action_cb),toto->tester->windowAction);
		gtk_widget_show(toto->tester->button);

		gtk_widget_show(toto->tester->pBox);
		gtk_box_pack_start(GTK_BOX (toto->tester->mainBox), toto->tester->pBox, TRUE, TRUE, 0);

		GTK_WIDGET_SET_FLAGS(toto->tester->button,GTK_CAN_DEFAULT);		//permet de simuler le click sur le bouton
		gtk_widget_grab_default(toto->tester->button);					//quand on appuye sur entren)

		gtk_widget_show(toto->tester->mainBox);
		gtk_widget_show(toto->tester->windowAction);

		test_f(toto);
	}
}

///////////////////////////////////////////////////////////////
void background_cb(GtkWidget* widget)
{
	switch(toto->debug)
	{
		case 0:
		background_f(toto);
		break;
		case 1:
		background_debug_f(toto);
		break;
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Fonctions appeles par les menus
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void ajouter_menu_cb(GtkWidget* widget)
{
	ajouter_cb(widget,toto);
}

void supprimer_menu_cb(GtkWidget* widget)
{
	supprimer_cb(widget,toto);
}

void liste_code_menu_cb(GtkWidget* widget)
{
	liste_code_cb(widget,toto);
}

void test_menu_cb(GtkWidget* widget)
{
	test_cb(widget,toto);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Fonctions principales Gtk et Gnome
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
static void create_toplevel_menu()
{
	gnome_mdi_set_menubar_template(mdi, main_menu);
}

////////////////////////////////////////////////////////////////
static GtkWidget* create_view(GnomeMDIChild* child, gpointer data)
{
	GtkWidget *quit_b;
	GtkWidget *ajouter_b;
	GtkWidget *supprimer_b;
	GtkWidget *test_b;
	GtkWidget *liste_b;
	GtkWidget *background_b;
	GtkWidget *Window;
	GtkWidget *Main_Box;
	GtkWidget *Box;

	Main_Box = gtk_hbox_new(FALSE, 5);
	gtk_container_border_width(GTK_CONTAINER(Main_Box), 5);
	Box = gtk_vbox_new(FALSE, 5);
	liste_b=gtk_button_new_with_label("Actions enregistres");
	gtk_signal_connect(GTK_OBJECT(liste_b),"clicked", GTK_SIGNAL_FUNC(liste_code_cb), toto);
	ajouter_b=gtk_button_new_with_label("Ajouter une action");
	gtk_signal_connect(GTK_OBJECT(ajouter_b),"clicked", GTK_SIGNAL_FUNC(ajouter_cb), toto);
	supprimer_b=gtk_button_new_with_label("Supprimer une action");
	gtk_signal_connect(GTK_OBJECT(supprimer_b),"clicked", GTK_SIGNAL_FUNC(supprimer_cb), toto);
	test_b=gtk_button_new_with_label("Tester une touche");
	gtk_signal_connect(GTK_OBJECT(test_b),"clicked", GTK_SIGNAL_FUNC(test_cb), toto);
	background_b=gtk_button_new_with_label("Lancer en arrire plan");
	gtk_signal_connect(GTK_OBJECT(background_b),"clicked", GTK_SIGNAL_FUNC(background_cb), toto);
	quit_b=gtk_button_new_with_label("Quitter");
	gtk_signal_connect(GTK_OBJECT(quit_b),"clicked", GTK_SIGNAL_FUNC(quit_cb), toto);

	gtk_box_pack_start(GTK_BOX(Box), liste_b, FALSE, FALSE, 5);
	gtk_widget_show(liste_b);
	gtk_box_pack_start(GTK_BOX(Box), ajouter_b, FALSE, FALSE, 5);
	gtk_widget_show(ajouter_b);
	gtk_box_pack_start(GTK_BOX(Box), supprimer_b, FALSE, FALSE, 5);
	gtk_widget_show(supprimer_b);
	gtk_box_pack_start(GTK_BOX(Box), test_b, FALSE, FALSE, 5);
	gtk_widget_show(test_b);
	gtk_box_pack_start(GTK_BOX(Box), background_b, FALSE, FALSE, 5);
	gtk_widget_show(background_b);

	/*
	toto->statusBar = gtk_statusbar_new();
	gtk_box_pack_end (GTK_BOX (Box), toto->statusBar, FALSE, FALSE, 0);
	gtk_widget_show (toto->statusBar);
	*/

	/*
	toto->statusBar = gnome_appbar_new(FALSE, TRUE, GNOME_PREFERENCES_NEVER);
	//  gnome_app_set_statusbar(GNOME_APP(app), toto->statusBar);
	gnome_app_set_statusbar(Main_Box, toto->statusBar);
	*/

	gtk_box_pack_end(GTK_BOX(Box), quit_b, FALSE, FALSE, 5);
	gtk_widget_show(quit_b);

	gtk_container_add(GTK_CONTAINER(Main_Box), Box);
	gtk_widget_show(Box);
	//gtk_window_set_position(GTK_WINDOW(Main_Box), GTK_WIN_POS_CENTER);
	gtk_widget_show(Main_Box);


	return GTK_WIDGET(Main_Box);
}

////////////////////////////////////////////////////////////////
static void new_child_cb(GtkWidget* widget, gpointer data)
{
	static gint num_fenetre=1;
	gchar name[32];
	GnomeMDIGenericChild* child;
	sprintf(name,"gIR");
	if ((child = gnome_mdi_generic_child_new(name)) != NULL)
	{
		gnome_mdi_generic_child_set_view_creator(child,create_view,NULL);
		gtk_object_set_user_data(GTK_OBJECT(child),GINT_TO_POINTER(num_fenetre));
		gnome_mdi_add_child(mdi,GNOME_MDI_CHILD(child));
		gnome_mdi_add_view(mdi,GNOME_MDI_CHILD(child));
		num_fenetre++;
	}
}

////////////////////////////////////////////////////////////////
int main(int argc,char *argv[])
{
	int fd;
	int i;
	int processus;
	char c;
	char *commande;
	int chiffres;
	chiffres=0;

	init_f();
	toto=(gtkBox*)malloc(sizeof(gtkBox));
	toto->code=(unsigned char*)malloc(65*sizeof(unsigned char));
	toto->debug=0;	//Par defaut, debugage dsactiv
	toto->bip=0;	//Par defaut, pas de beep

	if (argc<2)
	{
		////////////////////////////////////////////////////////////////
		// Version graphique

		toto->ajouter=(gtkBoxAjouter*)malloc(sizeof(gtkBoxAjouter));
		toto->supprimer=(gtkBoxSupprimer*)malloc(sizeof(gtkBoxSupprimer));
		toto->lister=(gtkBoxLister*)malloc(sizeof(gtkBoxLister));
		toto->tester=(gtkBoxTester*)malloc(sizeof(gtkBoxTester));

		gnome_init("gIR",VERSION,argc,argv);
		mdi=GNOME_MDI(gnome_mdi_new("(c) 2001","(c) CA XI"));

		//mdi = gnome_app_new ("gIR", _("gIR") );
		//gtk_widget_realize (mdi);

		gnome_mdi_set_mode(mdi,GNOME_MDI_TOPLEVEL);
		create_toplevel_menu(mdi);
		gtk_signal_connect(GTK_OBJECT(mdi),"destroy",GTK_SIGNAL_FUNC(quit_cb),toto);
		gnome_mdi_open_toplevel(mdi);
		new_child_cb(WindowBox,GNOME_STOCK_MENU_NEW);
		gtk_main();
	}
	else
	{
		////////////////////////////////////////////////////////////////
		// Version console

		if (strcasecmp(argv[1],"ajouter")==0 || strcasecmp(argv[1],"-a")==0)
		{
			if (argc>=3)
			{
				fd=ouverturePort(BLOQUANT);
				if (fd==0)
				{
					printf("Impossible d'ouvrir port COM2\nLe logiciel doit etre install en root\n");
					exit(-1);
				}
				i=0;
				if (argc>3 && strcmp(argv[2],"debug")==0)
				{
					while (i<32)
					{
						printf("\nOctet recu n%d ",i);
						fflush(stdout);
						toto->code[i]=lectureCaractere(fd);
						printbin(toto->code[i]);
						i++;
					}
					enregistre_code(analyse_code(toto->code),argv[3]);
				}
				else
				{
					while (i<32)
					{
						toto->code[i]=lectureCaractere(fd);
						i++;
					}
					enregistre_code(analyse_code(toto->code),argv[2]);
				}
				printf("\nCode ajout!\n");
			}
			else
			{
				printf("Il manque la commande  assigner au code infra rouge. Par exemple ./recepteur_IR ajouter halt (pour arreter le P.C.)\n");
				exit (-1);
			}
		}
		else if (strcasecmp(argv[1],"supprimer")==0 || strcasecmp(argv[1],"-s")==0 || strcasecmp(argv[1],"-d")==0)
		{
			if (argc<3)
			{
				fd=ouverturePort(BLOQUANT);
				if (fd==0)
				{
					printf("Impossible d'ouvrir port COM2\nLe logiciel doit etre install en root\n");
					exit(-1);
				}
				i=0;
				while (i<32)
				{
					toto->code[i]=lectureCaractere(fd);
					i++;
				}
				if (supprime_code(analyse_code(toto->code),NULL)) printf("Le code  supprimer n'a pas ete trouv\n");
				else printf("Le code  supprimer a t trouv et supprim\n");
			}
			else
			{
				if (supprime_code(NULL,argv[2])) printf("Le code  supprimer n'a pas ete trouv\n");
				else printf("Le code  supprimer a t trouv et supprim\n");
			}
		}
		else if (strcasecmp(argv[1],"background")==0 || strcasecmp(argv[1],"-b")==0)
		{
			processus=fork();
			if (processus > 0)
			{
				exit (0);
			}
			else if (processus == 0)
			{
				fd=ouverturePort(BLOQUANT);
				if (fd==0)
				{
					printf("Impossible d'ouvrir port COM2\nLe logiciel doit etre install en root\n");
					exit(-1);
				}
				while(1)
				{
					bzero(toto->code,65);
					i=0;
					if ((argc>=3) && strcmp(argv[2],"debug")==0)
					{
						while (i<32)
						{
							printf("\nOctet recu n%d ",i);
							fflush(stdout);
							toto->code[i]=lectureCaractere(fd);
							printbin(toto->code[i]);
							i++;
						}
						commande=cherche_code(analyse_code(toto->code));
						if (argc>=4)
						{
							if (strcmp(argv[3],"bip")==0)
							{
								//beep(void);
								printf("\a\a\a");
								fflush(stdout);
							}
						}
						if (commande!=NULL)
						{
							//fflush(stdout);
							printf("\nCorrespondance: \033[31;1m%s\033[0m\n",commande);

							i=0;
							while (i<strlen(commande)-1)
							{
								if (strncmp(commande+i,"%d",2)==0)
								{
									if (chiffres>0)
									{
										char *temp;
										temp=(char *)malloc(101*sizeof(char));
										strcpy(temp,commande);
										sprintf	(commande,temp,chiffres);
										free(temp);
									}
									else
									{
										if (commande[strlen(commande)-1]=='&') strcpy(commande+i," &");
										else commande[i]=0;
									}
									break;
								}
								i++;
							}

							if (strlen(commande)==1 && commande[0]>=48 && commande[0]<=57)	//est-ce un chiffre?
							{
								if (chiffres<0) chiffres=0;
								chiffres*=10;
								chiffres+=commande[0]-48;
								printf("\aChiffres vaut maintenant: %d\n",chiffres);
								continue;
							}
							else chiffres=-1;
							printf("On va lancer: %s\n",commande);
							system(commande);
						}
						else printf("\n\033[31;1mAucune correspondance trouve\033[0m\n");
					}
					else
					{
						while (i<32)
						{
							toto->code[i]=lectureCaractere(fd);
								i++;
						}
						commande=cherche_code(analyse_code(toto->code));
						if (argc>=3)
						{
							if (strcmp(argv[2],"bip")==0)
							{
								//beep(void);
								printf("\a\a\a");
								fflush(stdout);
							}
						}
						if (commande!=NULL)
						{

							fflush(stdout);
							i=0;
							while (i<strlen(commande)-1)
							{
								if (strncmp(commande+i,"%d",2)==0)
								{
									if (chiffres>0)
									{
										char *temp;
										temp=(char *)malloc(101*sizeof(char));
										strcpy(temp,commande);
										sprintf(commande,temp,chiffres);

										free(temp);
									}
									else
									{
									if (commande[strlen(commande)-1]=='&') strcpy(commande+i," &");
									else commande[i]=0;
									}
									break;
								}
								i++;
							}

							if (strlen(commande)==1 && commande[0]>=48 && commande[0]<=57)	//est-ce un chiffre?
							{
								if (chiffres<0) chiffres=0;
								chiffres*=10;
								chiffres+=commande[0]-48;
								printf("\a");
								fflush(stdout);
							continue;
							}
							else chiffres=-1;
							system(commande);
						}
					}
				}
				fermeturePort(fd);
			}
			else
			{
				printf("Erreur dans la mise en arriere plan\n");
			}

		}
		else if (strcasecmp(argv[1],"liste")==0 || strcasecmp(argv[1],"-l")==0)
		{
			FILE* fichier;
			unsigned char *codeLu;
			fd=ouverturePort(BLOQUANT);
			if (fd==0)
			{
				printf("Impossible d'ouvrir port COM2\nLe logiciel doit etre install en root\n");
				exit(-1);
			}
			bzero(toto->code,65);
			i=0;

			codeLu=(unsigned char *)malloc(65*sizeof(unsigned char));
			commande=(char *)malloc(64*sizeof(char));
			fichier=fopen(DATA_FILE,"r");
			if (fichier==NULL)
			{
				printf("Aucun code enregistr! (fichier inexistant)\n");
				exit(0);
			}

			do
			{
				fread(codeLu,1,64,fichier);
				fscanf(fichier," %[^\n]\n",commande);
				printf("Action : %s\n", commande);
			}
			while (!feof(fichier));
			fclose(fichier);
			free(commande);
		}
		else if (strcasecmp(argv[1],"test")==0 || strcasecmp(argv[1],"-t")==0)
		{
			fd=ouverturePort(BLOQUANT);
			if (fd==0)
			{
				printf("Impossible d'ouvrir port COM2\nLe logiciel doit etre install en root\n");
				exit(-1);
			}
			bzero(toto->code,65);
			i=0;
			while (i<32)
			{
				printf("\nOctet recu n%d ",i);
				fflush(stdout);
				toto->code[i]=lectureCaractere(fd);
				printbin(toto->code[i]);
				i++;
			}
			if (cherche_code(analyse_code(toto->code))!=NULL)
			{
				printf("\nCorrespondance: \033[31;1m%s\033[0m\n",cherche_code(analyse_code(toto->code)));
				system(cherche_code(analyse_code(toto->code)));
			}
			else printf("\n\033[31;1mAucune correspondance trouve\033[0m\n");
			fermeturePort(fd);
		}
		else
		{
			printf("Parametre incorrect. Lancez ./recepteur_IR pour plus d'informations\n");
			exit (-1);
		}
	}
	quit();
}




