/* gestion_code.c */

#include <stdio.h>
#include <unistd.h>
#include "gIR.h"
#include "reception.h"

////////////////////////////////////////////////////////////////
void printbin(unsigned char nombre)
	{
	int i;

	i=7;
	while (i>=0) printf("\033[35;1m%d\033[0m",1&nombre>>i--);
	}

////////////////////////////////////////////////////////////////
char lectureCaractere(int fd)
	{
	char c;
	read(fd,&c,1);
	return c;
	}

////////////////////////////////////////////////////////////////
unsigned char * analyse_code(unsigned char* code)
	{
	int position,nouvPos,bit,index;
	unsigned short int echantillon;
	unsigned char *nouvCode;

	nouvCode=(unsigned char*)malloc(65*sizeof(unsigned char));
	memcpy(nouvCode,code,64);

	position=0;
	bit=1<<7;
	while (code[position]&bit)
		{
		bit>>=1;
		if (bit==0)
			{
			bit=1<<7;
			position++;
			}
		}

	index=1<<7;
	nouvPos=0;
	while (position<65)
		{
		if (code[position]&bit)
			{
			nouvCode[nouvPos] |= index;
			}
		else
			{
			nouvCode[nouvPos] &= ~index;
			}
		bit>>=1;
		if (bit==0)
			{
			bit=1<<7;
			position++;
			}
		index>>=1;
		if (index==0)
			{
			index=1<<7;
			nouvPos++;
			}
		}

	nouvPos=0;
	index=1<<7;
	bit=1<<15;
	while (nouvPos<65)
		{
		if (nouvCode[nouvPos]&index)
			{
			echantillon |= bit;
			}
		else
			{
			echantillon &= ~bit;
			}
		index>>=1;
		if (index==0)
			{
			index=1<<7;
			nouvPos++;
			}
		bit>>=1;
		if (bit==0)
			{
			bit=1<<15;
			if (echantillon==0) break;
			}
		}

	if (nouvPos<65)
		{
		while (nouvPos<65)
			{
			nouvCode[nouvPos]=0;
			nouvPos++;
			}
		}

	position=0;
	while (position<65)
		{
		position++;
		}
	return nouvCode;
	}

////////////////////////////////////////////////////////////////
void enregistre_code(unsigned char *code,char *commande_assignee)
	{
	FILE *fichier;

	fichier=fopen(DATA_FILE,"a+");

	fwrite(code,1,64,fichier);
	fputc(' ',fichier);
	fprintf(fichier,"%s\n",commande_assignee);

	fclose(fichier);
	}

////////////////////////////////////////////////////////////////
char * cherche_code(unsigned char *code)
	{
	FILE *fichier;
	unsigned char *codeLu;
	char *commande;
	int trouve=0;

	codeLu=(unsigned char *)malloc(65*sizeof(unsigned char));
	commande=(char *)malloc(101*sizeof(char));

	fichier=fopen(DATA_FILE,"r");
	if (fichier==NULL)
		{
		printf("Aucun code enregistr! (fichier inexistant)\n");
		exit(-1);
		}

	do
		{
		fread(codeLu,1,64,fichier);
		fscanf(fichier," %[^\n]\n",commande);

		if (!memcmp(code,codeLu,64))
			{
			trouve=1;
			break;
			}
		}
	while (!feof(fichier));

	if (!trouve)
		{
		fclose(fichier);
		return NULL;
		}
	else
		{
		fclose(fichier);
		return commande;
		}
	}

////////////////////////////////////////////////////////////////
int supprime_code(unsigned char *code,char *commande_assignee)
	{
	FILE *fichier;
	unsigned char *codeLu;
	unsigned char *fichierCodes;
	char *commande;
	int taille;
	int trouve=0;
	fpos_t positionInit,positionFin,positionTemp;

	codeLu=(unsigned char *)malloc(65*sizeof(unsigned char));
	commande=(char *)malloc(101*sizeof(char));
	fichierCodes=NULL;

	fichier=fopen(DATA_FILE,"r+");
	if (fichier==NULL)
		{
		printf("Aucun code enregistr! (fichier inexistant)\n");
		exit(-1);
		}

	do
		{
		fgetpos(fichier,&positionInit);
		fread(codeLu,1,64,fichier);
		fscanf(fichier," %[^\n]\n",commande);
		if (commande_assignee!=NULL)
			{
			if (!strcmp(commande,commande_assignee))
				{
				trouve=1;
				break;
				}
			}
		else
			{
		if (!memcmp(code,codeLu,64))
				{
				trouve=1;
				break;
				}
			}
		}
	while (!feof(fichier));

	if (!trouve)
		{
		fclose(fichier);
		return -1;
		}
	else
		{
		fgetpos(fichier,&positionFin);
		taille=0;
		rewind(fichier);
		while (!feof(fichier))
			{
			fgetpos(fichier,&positionTemp);
			if (positionTemp!=positionInit)
				{
				fichierCodes=(unsigned char *)realloc(fichierCodes,(taille+1)*sizeof(unsigned char));
				fichierCodes[taille]=fgetc(fichier);
				taille++;
				}
			else fsetpos(fichier,&positionFin);
			}
		fclose(fichier);
		fichier=fopen(DATA_FILE,"w");
		fwrite(fichierCodes,1,taille-1,fichier);
		fclose(fichier);
		return 0;
		}
	}
